---
title: undefined
slug: Web/JavaScript/Reference/Global_Objects/undefined
tags:
  - JavaScript
  - Language feature
  - Reference
---
<div>{{jsSidebar("Objects")}}</div>

<p>The global <code><strong>undefined</strong></code> property represents the primitive value <code>{{Glossary("Undefined", "undefined")}}</code>. It is one of JavaScript's {{Glossary("Primitive", "primitive types")}}.</p>

<p>{{js_property_attributes(0,0,0)}}</p>

<div>{{EmbedInteractiveExample("pages/js/globalprops-undefined.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">undefined</pre>

<h2 id="Description">Description</h2>

<p><code>undefined</code> is a property of the <em>global object</em>. That is, it is a variable in global scope. The initial value of <code>undefined</code> is the primitive value <code>{{Glossary("Undefined", "undefined")}}</code>.</p>

<p>In modern browsers (JavaScript 1.8.5 / Firefox 4+), <code>undefined</code> is a non-configurable, non-writable property, per the ECMAScript 5 specification. (Even when this is not the case, avoid overriding it.)</p>

<p>A variable that has not been assigned a value is of type <code>undefined</code>. A method or statement also returns <code>undefined</code> if the variable that is being evaluated does not have an assigned value. A function returns <code>undefined</code> if a value was not {{jsxref("Statements/return", "returned")}}.</p>

<div class="note">
<p><strong>Be careful.</strong> While it is possible to use it as an {{Glossary("identifier")}} (variable name) in any scope other than the global scope (because <code>undefined</code> is not a {{jsxref("Reserved_Words", "reserved word", "", 1)}}), doing so is a very bad idea that will make your code difficult to maintain and debug.</p>

<pre class="brush: js example-bad notranslate">//  DON'T DO THIS

//  logs "foo string"
(function() {
  var undefined = 'foo';
  console.log(undefined, typeof undefined);
})();

//  logs "foo string"
(function(undefined) {
  console.log(undefined, typeof undefined);
})('foo');
</pre>
</div>

<h2 id="Examples">Examples</h2>

<h3 id="Strict_equality_and_undefined">Strict equality and undefined</h3>

<p>You can use <code>undefined</code> and the strict equality and inequality operators to determine whether a variable has a value. In the following code, the variable <code>x</code> is not initialized, and the <code>if</code> statement evaluates to true.</p>

<pre class="brush: js notranslate">var x;
if (x === undefined) {
  // these statements execute
}
else {
  // these statements do not execute
}
</pre>

<div class="note">
<p><strong>Note:</strong> The <em>strict equality</em> operator (as opposed to the <em>standard equality</em> operator) must be used here, because <code>x == undefined</code> also checks whether <code>x</code> is <code>null</code>, while strict equality doesn't. This is because <code>null</code> is not equivalent to <code>undefined</code>.</p>

<p>See {{jsxref("Operators/Comparison_Operators", "comparison operators", "", 1)}} for details.</p>
</div>

<h3 id="typeof_operator_and_undefined">typeof operator and undefined</h3>

<p>Alternatively, {{jsxref("Operators/typeof", "typeof")}} can be used:</p>

<pre class="brush: js notranslate">var x;
if (typeof x === 'undefined') {
   // these statements execute
}
</pre>

<p>One reason to use {{jsxref("Operators/typeof", "typeof")}} is that it does not throw an error if the variable has not been declared.</p>

<pre class="brush: js notranslate">//  x has not been declared before
if (typeof x === 'undefined') { //  evaluates to true without errors
   //  these statements execute
}

if (x === undefined) { //  throws a ReferenceError

}
</pre>

<p>However, there is another alternative. JavaScript is a statically scoped language, so knowing if a variable is declared can be read by seeing whether it is declared in an enclosing context.</p>

<p>The global scope is bound to the {{jsxref("globalThis", "global object", "", 1)}}, so checking the existence of a variable in the global context can be done by checking the existence of a property on the <em>global object</em>, using the {{jsxref("Operators/in", "in")}} operator, for instance:</p>

<pre class="brush: js notranslate">if ('x' in window) {
  //  these statements execute only if x is defined globally
}</pre>

<h3 id="void_operator_and_undefined">void operator and undefined</h3>

<p>The {{jsxref("Operators/void", "void")}} operator is a third alternative.</p>

<pre class="brush: js notranslate">var x;
if (x === void 0) {
  //  these statements execute
}

//  y has not been declared before
if (y === void 0) {
  //  throws Uncaught ReferenceError: y is not defined
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-undefined', 'undefined')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.undefined")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>JavaScript's {{Glossary("Primitive", "primitive types")}}</li>
 <li>{{jsxref("null")}}</li>
</ul>
